// MazeGenerator.java
//
// ICS 23 Project #1: Dark at the End of the Tunnel
// Coded by Alex Thornton Fall 2002
// Minor edits by Norman Jacobson January 2003


// The MazeGenerator interface defines the behavior of a maze generator
// object.

/**
 * Describes all functions to implemented by MazeGenerators.
 */
public interface MazeGenerator
{
	// generateMaze() returns a new two-dimensional Maze of the given width
	// and height. The maze is generated in a series of steps from an
	// "initial maze" -- a maze where every cell has four walls -- into
	// a "completed maze" -- one that has the maze properties described in the
	// lab assignment. The MazeGeneratorListener is notified each time a step
	// towards the completed maze is taken, so that, if animation has been turned on,
	// the GUI is updated.
	/**
	 * Creates a new Maze of the specified dimensions using animation.
	 * @param width    the required x-dimension of the maze
	 * @param height   the required y-dimension of the maze
	 * @param listener the animator object
	 * @return the new Maze
	 * @see Maze
	 * @see MazeGeneratorListener
	 */
	public Maze generateMaze(int width, int height, MazeGeneratorListener listener);
}
