// MazeSolver.java
//
// ICS 23 Project #1: Dark at the End of the Tunnel
// Coded by Alex Thornton Fall 2002
// Minor edits by Norman Jacobson January 2003


// The MazeSolver interface defines the behavior of a maze solver.  A maze
// solver finds a solution to a maze, that is, a sequence of legal moves leading
// from the starting position of the maze to its ending position.  As each new
// move towards a solution is made, the MazeSolverListener object is notified so
// that the listener can update the GUI display (if the solution is being animated).

public interface MazeSolver
{
	// solveMaze() finds a solution to the given maze, returning it as a
	// MazeSolution object.  The given MazeSolverListener object is
	// notified each time a a step towards finding a solution is taken.
	public MazeSolution solveMaze(Maze maze, MazeSolverListener listener);
}
