// MazeSolverListener.java
//
// ICS 23 Project #1: Dark at the End of the Tunnel
// Coded by Alex Thornton Fall 2002
// Minor edits by Norman Jacobson January 2003


// The MazeSolverListener defines a set of notification methods that
// are to be called while a maze is being solved.

public interface MazeSolverListener
{
	// startingMazeSolution() is to be called when the maze solving
	// process has just begun, after the MazeSolution has been created.
	// The newly-created MazeSolution should be the passed parameter.
	public void startingMazeSolution(MazeSolution solution);

	// solutionChanged() is to be called every time a change is made
	// in the solution being generated.  The current MazeSolution
	// object should be the passed parameter.
	public void solutionChanged(MazeSolution solution);
}
